//+------------------------------------------------------------------+
//|                                               Waddah Attar Pivot |
//|                        Copyright  2007, waddahattar@hotmail.com |
//|                             Waddah Attar waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, waddahattar@hotmail.com"
#property link      "waddahattar@hotmail.com"
//----
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  Red
#property indicator_color2  Blue
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern bool   alertsOn                  = true;
extern bool   alertsOnDailyPivotCross   = true;
extern bool   alertsOnWeeklyPivotCross  = true;
extern bool   alertsOnMonthlyPivotCross = true;
extern bool   alertsOnCurrent           = true;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = false;
extern bool   alertsNotify              = false;
extern bool   alertsEmail               = false;

//
//
//
//
//

double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double trend1[];
double trend2[];
double trend3[];
double PP, Q;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(6);
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);
   SetIndexBuffer(2, P3Buffer);
   SetIndexBuffer(3, trend1);
   SetIndexBuffer(4, trend2);
   SetIndexBuffer(5, trend3);
   Comment("Waddah Attar Pivot");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("DayP");
   ObjectDelete("WeekP");
   ObjectDelete("MonthP");
   ObjectDelete("txtDayP");
   ObjectDelete("txtWeekP");
   ObjectDelete("txtMonthP");

   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars-1);
           
   //
   //
   //
   //
   //
         
   for(i = limit; i >= 0; i--)
   {
       int day1   = iBarShift(Symbol(), PERIOD_D1, Time[i], false);
       double Q1  = (iHigh(Symbol(), PERIOD_D1,day1 + 1) - iLow(Symbol(), PERIOD_D1, day1 + 1));
       double PP1 = (iHigh(Symbol(), PERIOD_D1,day1 + 1) + iLow(Symbol(), PERIOD_D1, day1 + 1) + iClose(Symbol(), PERIOD_D1, day1 + 1)) / 3;    
       //----
       P1Buffer[i] = PP1;
       SetPrice("DayP", Time[i], PP1, indicator_color1);
       SetText("txtDayP", "Day Pivot", Time[i], PP1, indicator_color1);

       int day2   = iBarShift(Symbol(), PERIOD_W1, Time[i], false);
       double Q2  = (iHigh(Symbol(), PERIOD_W1,day2 + 1) - iLow(Symbol(), PERIOD_W1, day2 + 1));
       double PP2 = (iHigh(Symbol(), PERIOD_W1,day2 + 1) + iLow(Symbol(), PERIOD_W1, day2 + 1) + iClose(Symbol(), PERIOD_W1, day2 + 1)) / 3;    
       //----
       P2Buffer[i] = PP2;
       SetPrice("WeekP", Time[i], PP2, indicator_color2);
       SetText("txtWeekP", "Week Pivot", Time[i], PP2, indicator_color2);

       int day3   = iBarShift(Symbol(), PERIOD_MN1, Time[i], false);
       double Q3  = (iHigh(Symbol(), PERIOD_MN1,day3 + 1) - iLow(Symbol(), PERIOD_MN1, day3 + 1));
       double PP3 = (iHigh(Symbol(), PERIOD_MN1,day3 + 1) + iLow(Symbol(), PERIOD_MN1, day3 + 1) + iClose(Symbol(), PERIOD_MN1, day3 + 1)) / 3;    
       //----
       P3Buffer[i] = PP3;
       SetPrice("MonthP", Time[i], PP3, indicator_color3);
       SetText("txtMonthP", "Month Pivot", Time[i], PP3, indicator_color3);
       trend1[i] = trend1[i+1];
       trend2[i] = trend2[i+1];
       trend3[i] = trend3[i+1];
       if (Close[i]>P1Buffer[i]) trend1[i] = 1;
       if (Close[i]<P1Buffer[i]) trend1[i] =-1;
       if (Close[i]>P2Buffer[i]) trend2[i] = 1;
       if (Close[i]<P2Buffer[i]) trend2[i] =-1;
       if (Close[i]>P3Buffer[i]) trend3[i] = 1;
       if (Close[i]<P3Buffer[i]) trend3[i] =-1; 

    }
   manageAlerts();  
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetPrice(string name, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_ARROW, 0, Tm, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     } 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetText(string name, string txt, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_TEXT, 0, Tm, Prc);
       ObjectSetText(name, txt, 10, "Times New Roman", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSetText(name, txt, 10, "Times New Roman", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     } 
  }
//+------------------------------------------------------------------+

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnDailyPivotCross && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," Price crossing Waddah Attar Daily Pivot up");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," Price crossing Waddah Attar Daily Pivot down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnWeeklyPivotCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," Price crossing Waddah Attar Weekly Pivot up");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," Price crossing Waddah Attar Weekly Pivot down");
         } 
      static datetime time3 = 0;
      static string   mess3 = "";
         if (alertsOnMonthlyPivotCross && trend3[whichBar] != trend3[whichBar+1])
         {
            if (trend3[whichBar] ==  1) doAlert(time3,mess3,whichBar," Price crossing Waddah Attar Monthly Pivot up");
            if (trend3[whichBar] == -1) doAlert(time3,mess3,whichBar," Price crossing Waddah Attar Monthly Pivot down");
         }                       
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Waddah Attar Pivot " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Waddah Attar Pivot "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}